<template>
    <div class="NewElementList">

        <div class="text-center">
            <h1>Ajout d'un nouvel item</h1>
        </div>

        <div class="FormElement">

            <div class="form-group">
                <label for="libelle">Libelle</label>
                <input type="text" class="form-control" id="libelle" v-model="newElement.libelle" placeholder="libelle"/>
            </div>

            <div class="form-group">
                <label for="prix">Prix</label>
                <input type="number" class="form-control" id="prix" min="0" v-model="newElement.prix"/>
            </div>


            <div class="form-group">
                <label for="description">Description</label>
                <input type="text" class="form-control" id="description" v-model="newElement.description" />
            </div>

            <div class="text-center">
                <button type="button" class="btn btn-success mr-2" @click="addElement">Valider</button>
                <router-link :to="{name: 'consultation', params: {id: $route.params.id}}">
                    <button type="button" class="btn btn-primary">retour</button>
                </router-link>
            </div>

        </div>

    </div>
</template>

<script>
    export default {
        name: 'NewElementListe',
        data: ()=>  ({
            element: [],
            newElement: {
                'libelle': '',
                'prix': 0,
                'description': ''
            }
        }),
        methods: {
            addElement() {

                //ID param
                let id = this.$route.params.id;
                let objs = JSON.parse(localStorage.getItem('listes'));
                let index = objs.findIndex(list => list.id === id);

                //Element a push dans la liste d'items
                const elem = {
                    id: this.getLastIdItems(objs[index]) + 1,
                    libelle: this.newElement.libelle,
                    prix: this.newElement.prix,
                    description: this.newElement.description
                };

                //Push de l'item
                objs[index].items.push(elem);

                /*objs.forEach(function(item){
                    if(item.id == id){
                        item.items.push(elem);
                    }
                });*/

                //Sauvegarde des listes
                localStorage.setItem('listes', JSON.stringify(objs));

                //Redirection vers la consultation
                this.$router.push({
                    path: `/list/${id}`
                })

            },
            getLastIdItems (liste){

                let val;

                if(!liste.items || liste.items.length === 0 ){
                    val = 0;
                }else {
                    val = liste.items[liste.items.length - 1].id;
                }

                return val;
            }
        }
    }
</script>